#include <iostream>
#include <time.h>
#include "emergency.h"

using namespace std;

void
Emergency::
fire_emergency()
{
    mtx_.lock();
    time_t t = time(NULL);
    tm* now = localtime(&t);
    int hr = now->tm_hour;
    int min = now->tm_min;
    int sec = now->tm_sec;
    cout
         << hr << ':' << min << ':' << sec
         << "            Help! Call the firemen! " << endl;
    sleep(10);          // intervention lasts 10 s
    t = time(NULL);
    now = localtime(&t);
    hr = now->tm_hour;
    min = now->tm_min;
    sec = now->tm_sec;
    cout
         << hr << ':' << min << ':' << sec
         << "            Fire extinguished! " << endl;
    mtx_.unlock();
}

void
Emergency::
power_emergency()
{
    mtx_.lock();
    time_t t = time(NULL);
    tm* now = localtime(&t);
    int hr = now->tm_hour;
    int min = now->tm_min;
    int sec = now->tm_sec;
    cout
         << hr << ':' << min << ':' << sec
         << "            Help! Call the electrician!" << endl;
    sleep(3);          // intervention lasts 3 s
    t = time(NULL);
    now = localtime(&t);
    hr = now->tm_hour;
    min = now->tm_min;
    sec = now->tm_sec;
    cout
         << hr << ':' << min << ':' << sec
         << "            Breaker replaced! " << endl;
    mtx_.unlock();
}
