#ifndef __CHANNEL__
#define __CHANNEL__

#include <boost/thread/thread.hpp>
#include <boost/thread/mutex.hpp>
#include <boost/thread/condition.hpp>
#include <iostream>

#include "typedefs.h"

class channel {
    boost::mutex start_mtx_;
    boost::mutex stop_mtx_;
    boost::condition start_sem_;
    boost::condition stop_sem_;
    bool started_;
    bool stopped_;
public:
    channel();
    void signal_start();
    void signal_stop();
    void wait_start();
    void wait_stop();
    bool stopped();
};

#endif
