#ifndef __CONTROLLER__
#define __CONTROLLER__

#include <boost/thread/thread.hpp>
#include <boost/thread/mutex.hpp>
#include <boost/thread/condition.hpp>
#include <iostream>

#include "typedefs.h"
#include "channel.h"

using namespace std;

class Controller;
// controller thread body
void cthrd_body_(Controller* const ctrl);

class Controller {
    boost::thread* thrd_;
//    static void cthrd_body_();  // controller thread body
//    boost::thread thrd_(&Controller::cthrd_body_);
    channel* fch_;       // channel to fire monitor
    channel* pch_;       // channel to power monitor
    channel* sch_;       // channel from main
friend
    void cthrd_body_(Controller* const ctrl);
public:
    Controller(channel* fch, channel* pch, channel* sch);
    void join();
};


#endif

