#include <stdlib.h>
#include <time.h>
#include <chrono>
#include <iostream>
#include "powersensor.h"

using namespace std;

static auto
    start = std::chrono::high_resolution_clock::now();    // initial time

PowerSensor::
PowerSensor()
{
//    srand(time(NULL));
}

bool
PowerSensor::
pwr_up()
{
    auto now = std::chrono::high_resolution_clock::now();    // curremt time
    double
        delta = std::chrono::duration<double, std::milli>(now - start).count();

    if (delta < 5000)          // detect pwr failure after 5 s
        return true;
    else {
        time_t t = time(NULL);
        tm* now = localtime(&t);
        int hr = now->tm_hour;
        int min = now->tm_min;
        int sec = now->tm_sec;
        cout << hr << ':' << min << ':' << sec
	     << "          PowerSensor: power failure" << endl;
        return false;
    }
}

//bool
//PowerSensor::
//pwr_up()
//{
//    int i = rand()%10;
//    return pwr_[i];
//}
